=== LZ4/CMakeLists.txt ===
message(STATUS "Building with LZ4 plugin")

#==============================================================================
# set the plugin name
#==============================================================================
set(PLUGIN_NAME hdf5lz4)

#==============================================================================
# add source directories
#==============================================================================
add_subdirectory(src)
add_subdirectory(test)
