=== bitshuffle/CMakeLists.txt ===

add_subdirectory(src)
add_subdirectory(test)
