=== debian/control ===
Source: hdf5-filter-plugin
Priority: optional
Section: science
Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13)
	, cmake
	, libhdf5-dev
	, liblz4-dev
	, libbz2-dev
	, pkgconf
Homepage: https://github.com/nexusformat/HDF5-External-Filter-Plugins
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/hdf5-filter-plugin
Vcs-Git: https://salsa.debian.org/science-team/hdf5-filter-plugin.git

Package: hdf5-filter-plugin
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: hdf5-filter-plugin-bz2-serial, hdf5-filter-plugin-lz4-serial
Multi-Arch: foreign
Description: external filters for HDF5: LZ4, BZip2
 The external filter mechanism introduced with HDF5 1.8.12 allows
 applications to utilize custom filters not shipped by the HDF5
 core library without recompiling your application. This package
 provides external filters for HDF5 for
 .
  - the LZ4 compression algorithm
  - BZip2 compression
