=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildtools.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PLUGIN_DIR=$(shell $(PKG_CONFIG) hdf5-serial  --variable=PluginDir|sed "s?/plugins??")

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake -- \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
		-DENABLE_LZ4_PLUGIN=yes \
		-DENABLE_BZIP2_PLUGIN=yes \
		-DCMAKE_INSTALL_LIBDIR=${PLUGIN_DIR}

override_dh_auto_install:
	dh_auto_install --destdir=debian/hdf5-filter-plugin/
	find
