=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
  https://github.com/nexusformat/HDF5-External-Filter-Plugins \
  HEAD debian uupdate
